clc
clear
format long

delta = 0.01;
A = [1 7;0 delta^2]
q = [1;delta]
%A = [2 7 3;0 1 4; 0 0 delta^2]
%q = [1;1;delta]
A1 = A';

% we solve Az=q with Iter regularization
z0 = lsqr([1 7;0 0],[1;0]);
%z0 = lsqr([2 7 3;0 1 4; 0 0 0],[1;1;0])


A2 = -1/2*A*A1

l = [0;0];
%l = [0;0;0];

%figure;
N = 100;
dd = zeros(1,N);
for k=1:N
    alpha_k = 0*k^(-1/6);
    beta_k = 1*k^(-3/5);
    d = A2*l - q  - 2*alpha_k*l;
    l = l+beta_k*d;
    z = -1/2*A1*l;
    difference = z-z0;
    fprintf('k = %d\t\tl = %f %f\t\tz = %f %f\t\tdifference = |%f|\n',k, l(1), l(2), z(1), z(2), norm(difference));
    dd(k) = norm(d);
    %plot( z(1), z(2), '.'); hold on;
end
plot(1:N,dd);

fprintf('k = %d\t\tl = %f %f\t\tz = %f %f\n',k, l(1), l(2), z(1), z(2));

%ezsurf('-1/4*(x*(2*x+0.01^2*y)+y*(0.01^2*x+0.01^4*y))-x-0.01*y',[-100,100,-100,100]);