%%

clear
delta = 0.01;
Ad = [1 1; 0 delta ];
bd = [1;delta^2];
syms x y real
l = [x;y];
Vd = -1/4*l'*Ad*Ad'*l-l'*bd;
simplify(Vd)

ezsurf(- x^2/2 - (x*y)/200 - x - y^2/40000 - y/10000)

%%
syms delta l1 l2 real
l = [l1;l2]

A = [1 1;0 delta]
q = [1;delta^2]

Vd = -1/4*l'*A*A'*l-l'*q;

V = simplify(Vd)
V_l1 = simplify(diff(Vd,l1))
V_l2 = simplify(diff(Vd,l2))
[w1,w2] = solve(V_l1==0,V_l2==0,l1,l2)
l_extr = simplify([w1;w2])
z_extr = simplify(-1/2*A'*l_extr)
% must  be zero vector
difference = simplify(A*z_extr - q)
%%
clc ; clear
syms delta l1 l2 real
l = [l1;l2]

A = [1+delta 7;0 delta^2]
q = [1;delta]

Vd = -1/4*l'*A*A'*l-l'*q

dV = -1/2*A*A'*l-q

l_next = l+dV
z_next = -1/2*A'*l_next

V = simplify(Vd)
V_l1 = simplify(diff(Vd,l1))
V_l2 = simplify(diff(Vd,l2))
[w1,w2] = solve(V_l1==0,V_l2==0,l1,l2)
l_extr = simplify([w1;w2])
z_extr = simplify(-1/2*A'*l_extr)
% must  be zero vector
difference = simplify(A*z_extr - q)
%%
clc
clear
syms delta l1 l2 l3 real
l = [l1;l2;l3]

A = [1 2 1;0 1 1; 0 0 delta^2]
q = [1;1;delta]

Vd = -1/4*l'*A*A'*l-l'*q;

dV = -1/2*A*A'*l-q

V = simplify(Vd)
V_l1 = simplify(diff(Vd,l1));
V_l2 = simplify(diff(Vd,l2));
V_l3 = simplify(diff(Vd,l3));
[w1,w2,w3] = solve(V_l1==0,V_l2==0,V_l3==0,l1,l2,l3);
l_extr = simplify([w1;w2;w3])
z_extr = simplify(-1/2*A'*l_extr)
% must  be zero vector
difference = simplify(A*z_extr - q)
%%
syms a b delta1 delta2 delta3 delta4 y1 y2 l1 l2 real
l = [l1;l2]

A = [1 1;a+delta1 b+delta2]
q = [y1+delta3;y2+delta4]

Vd = -1/4*l'*A*A'*l-l'*q;

V = simplify(Vd)
V_l1 = simplify(diff(Vd,l1))
V_l2 = simplify(diff(Vd,l2))
[w1,w2] = solve(V_l1==0,V_l2==0,l1,l2)
l_extr = simplify([w1;w2])
z_extr = simplify(-1/2*A'*l_extr)
% must  be zero vector
difference = simplify(A*z_extr - q)

