clear all
syms x t
y =  sin(x+pi/4)/exp(t);
E = diff(y,t) - diff(diff(y,x),x);
b1 = diff(y,x) - y;
b2 = diff(y,x) + y;

L = pi/2;
T = 0.001;
nx = 16;
nt = 64;
y = @(x,t) (sin(x+pi/4)/exp(t));
v = @(x) (sin(x+pi/4));
yT = @(x) (sin(x+pi/4))/exp(T);
[v,x] = approxFunction(v,0,L,nx);
[A,b,x,t] = approxParabolicEquation(L,T,nx,nt,v);
yyT = A*v;


nx = 128;
nt = 8;
y = @(x,t) (sin(x+pi/4)/exp(t));
v = @(x) (sin(x+pi/4));
yT = @(x) (sin(x+pi/4))/exp(T);
[v,x2] = approxFunction(v,0,L,nx);
[A,b,x2,t] = approxParabolicEquation(L,T,nx,nt,v);
yyT2 = A*v;

plot(x,yT(x),'-b', x, yyT,'-g', x2,yyT2,'-r');