function [A,u,x,s] = approxFredholmEquation(K,u,a,b,ns,c,d,nx)
    hx = (d-c)/(nx-1);
    hs = (b-a)/(ns-1);
    x = c:hx:d;
    s = a:hs:b;
    I1 = [1 2*ones(1,numel(s)-2),1].*hs/2;
    %I2 = [1 kron(ones(1,(numel(s)-3)/2),[4 2]) 4 1].*hs/3;
    A = kron(I1, ones(numel(x),1)).*K;
end