function [K,x,s] = approxFredholmKernel(Kfun,a,b,ns,c,d,nx)
    hx = (d-c)/(nx-1);
    hs = (b-a)/(ns-1);
    x = (c:hx:d)';
    s = a:hs:b;
    xx = kron(ones(1,numel(s)),x);
    ss = kron(s,ones(numel(x),1));
    K = Kfun(xx,ss);
end