function [z, lambda] = closedCircuitExperimentFredholm(solver,K,z0,a,b,ns,c,d,nx,delta,varargin)
    u = zeros(nx,1);
    [A,u,x,s] = approxFredholmEquation(K,u,a,b,ns,c,d,nx);
    A
    eigsA = svd(A)
    u = A*z0;
    d = rand(size(u))-0.5*ones(size(u));
    d = delta.*d./norm(d);
    udelta = u+d;
    
    h = rand(size(K))-0.5*ones(size(K));
    h = delta.*h./norm(h);
    Kh = K+h;
    
    [z, lambda] = solver(Kh,udelta,a,b,ns,c,d,nx, varargin{:});
end